/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.24 from the
 * contents of Data.xs. Do not edit this file, edit Data.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Data.xs"
//depot/Audio/Data/Data.xs#19 - edit change 2568 (text)
/*
  Copyright (c) 1996, 2001 Nick Ing-Simmons. All rights reserved.
  This program is free software; you can redistribute it and/or
  modify it under the same terms as Perl itself.
*/
#define PERL_NO_GET_CONTEXT

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>
#include "Audio_f.h"

#define AUDIO_CLASS(sv) (HvNAME(SvSTASH(SvRV(sv))))

float *
Audio_more(pTHX_ Audio *au, int n)
{
 STRLEN sz = n * sizeof(float) * AUDIO_WORDS(au);
 float  *p = (float *) (SvGROW(au->data,SvCUR(au->data)+sz) + SvCUR(au->data));
 SvCUR(au->data) += sz;
 Zero(p,n,float);
 return p;
}

Audio *
Audio_new(pTHX_ SV **svp, int rate, int flags, int samples, char *class)
{
 SV *sv = (svp) ? *svp : Nullsv;
 Audio tmp;
 Zero(&tmp,1,Audio);
 tmp.data  = newSVpvn("",0);
 tmp.rate  = rate;
 tmp.flags = flags;
 if (samples)
   Audio_more(aTHX_ &tmp,samples);
 if (!sv) {
  sv = sv_2mortal(newSV(0));
  if (svp)
   *svp = sv;
 }
 if (!class)
  class = "Audio::Data";
 sv_setref_pvn(sv,class,(char *)&tmp,sizeof(tmp));
 return (Audio *) SvPV_nolen((SV*)SvRV(sv));
}

float *
Audio_complex(Audio *au)
{
 if (!AUDIO_COMPLEX(au))
  {
   dTHX;
   int n = Audio_samples(au);
   float *r;
   float *c;
   Audio_more(aTHX_ au,n);
   r = AUDIO_DATA(au)+n-1;    /* Last old sample */
   c = AUDIO_DATA(au)+2*n-1;  /* Imaginary part of new last */
   while (c > r)
    {
     *c-- = 0.0;              /* Imaginary part is 0 */
     *c-- = *r--;             /* Copy real part */
    }
   au->flags |= AUDIO_F_COMPLEX;
  }
 return AUDIO_DATA(au);
}

static float *
Audio_pow2(pTHX_ Audio *au)
{
 STRLEN have = Audio_samples(au);
 STRLEN n = 1;
 while (n < have)
  n <<= 1;
 if (n > have)
  Audio_more(aTHX_ au,n-have);
 return Audio_complex(au);
}


/* Does not take pTHX_ to keep external API easy */
SV *
Audio_shorts(Audio *au)
{
 dTHX;
 SV *tmp = newSVpv("",0);
 STRLEN samp = Audio_samples(au);
 short *p    = (short *) SvGROW(tmp,samp*sizeof(short));
 float *data = AUDIO_DATA(au);
 int words = AUDIO_WORDS(au);
 SvCUR(tmp) = samp*sizeof(short);
 while (samp--)
  {
   *p++ = float2linear(*data,16);
   data += words;
  }
 return tmp;
}

void
Audio_tone(Audio *au, float freq, float dur, float amp)
{
 dTHX;
 unsigned samp = (int) (dur * au->rate);
 float *buf = Audio_more(aTHX_ au, samp);
 double th  = 0.0;
 double inc = 2*AUDIO_PI*freq/au->rate;
 int words = AUDIO_WORDS(au);
 while (samp > 0)
  {
   *buf = amp * sin(th);
   th += inc;
   buf += words;
   samp--;
  }
}

void
Audio_noise(Audio *au, float dur, float amp)
{
 dTHX;
 unsigned samp = (int) (dur * au->rate);
 float *buf = Audio_more(aTHX_ au, samp);
 int words = AUDIO_WORDS(au);
 while (samp > 0)
  {
   *buf = amp * (Drand01()-0.5);
   samp--;
   buf += words;
  }
}

static void
Audio_fft(pTHX_ Audio *au,fft_f *fft)
{
 float *data = Audio_pow2(aTHX_ au);
 (*fft)(Audio_samples(au),data);
}

#define AUDIO_r2_fft(au)    Audio_fft(aTHX_ au,&Audio_r2_fft)
#define AUDIO_r2_ifft(au)   Audio_fft(aTHX_ au,&Audio_r2_ifft)
#define AUDIO_r4_fft(au)    Audio_fft(aTHX_ au,&Audio_r4_fft)
#define AUDIO_r4_ifft(au)   Audio_fft(aTHX_ au,&Audio_r4_ifft)
#define AUDIO_conjugate(au,scale) Audio_conjugate(Audio_samples(au),Audio_complex(au),scale);
#define AUDIO_complex_debug(au,f) Audio_complex_debug(Audio_samples(au),Audio_complex(au),f);

#define IS_AUDIO(sv) (SvROK(sv) && sv_isobject(sv) && sv_derived_from(sv,"Audio::Data"))

Audio *
Audio_from_sv(pTHX_ SV *sv)
{
 if (SvGMAGICAL(sv))
  mg_get(sv);
 if (SvROK(sv) && sv_isobject(sv) && sv_derived_from(sv,"Audio::Data"))
  {
   STRLEN len;
   return (Audio *) SvPV(SvRV(sv),len);
  }
 return NULL;
}

float
Audio_FIR(Audio *au,float x0)
{
/* FIR filter is represented as an array of floats
   H(z) = b0 + b1*z**1 + b2*z**2 ... bN*z**N
   Thus next output sample is given by :
   y(n) = b0 * x(n) + b1 * x(n-1) ... + bN * x(n-N)
   The float vector has N+1 entries at the start for the b0..bN
   and then (N) entries for the storage elements.
   Thus Audio_samples(filter) == 2*N+1
*/
 int    N = (Audio_samples(au)-1)/2;
 float *b = AUDIO_DATA(au)+N;   /* last b */
 float *x = b+N;                /* last x */
 float y  = *b-- * *x--;
 int k;
 for (k = N-1; k > 0; k--)
  {
   x[1] = *x;
   y   += *b-- * *x--;
  }
 x[1] = x0;
 y   += *b * x0;
 return y;
}

float
Audio_AllPole(Audio *au,float x)
{
/* An AllPole filter is represented as an array of floats
   H(z) = 1/(a0 + a1*z**1 + a2*z**2 ... aN*z**N)
   Thus next output sample is given by :
   y(n) = a0 * x(n) + a1 * y(n-1) ... + aN * y(n-N)
   The float vector has N+1 entries at the start for the a0..aN
   and then (N) entries for the storage elements.
   Thus Audio_samples(filter) == 2*N+1
*/
 int    N = (Audio_samples(au)-1)/2;
 float *a = AUDIO_DATA(au)+N;   /* last b */
 float *y = a+N;                /* last x */
 float yn = *a-- * *y--;
 int k;
 for (k = N-1; k > 0; k--)
  {
   yn  += *a-- * *y;
   y[1] = *y;
   y--;
  }
 yn  += *a * x;
 y[1] = yn;
 return yn;
}

int
Audio_filter_sv(pTHX_ Audio *filter, float (*func)(Audio *,float), Audio *lau, SV *sv)
{
 int count = 0;
 Audio *rau = Audio_from_sv(aTHX_ sv);
 if (rau)
  {
   STRLEN n = Audio_samples(rau);
   float *s = AUDIO_DATA(rau);
   float *d = Audio_more(aTHX_ lau,n);
   while (n-- > 0)
    {
     *d++ = (*func)(filter,*s++);
    }
   count = n;
  }
 else if (SvROK(sv) && !sv_isobject(sv))
  {
   if (SvTYPE(SvRV(sv)) == SVt_PVAV)
    {
     AV *av = (AV *) SvRV(sv);
     int i;
     int l = av_len(av);
     for (i=0; i <= l; i++)
      {
       SV **svp = av_fetch(av,i,0);
       if (svp)
        count += Audio_filter_sv(aTHX_ filter,func,lau,*svp);
      }
    }
   else
    Perl_croak(aTHX_ "Cannot process reference");
  }
 else
  {
   float v = (*func)(filter,SvNV(sv));
   *(Audio_more(aTHX_ lau,1)) = v;
   count = 1;
  }
 return count;
}

int
Audio_filter_process(pTHX_ Audio *au,float (*func)(Audio *,float),int items,SV **svp)
{
 dSP;
 int offset = svp - sp;
 int count  = 0;
 int i;
 SV *result = Nullsv;
 Audio *tmp = Audio_new(aTHX_ &result,au->rate,au->flags,0,0);
 for (i=1; i < items; i++)
  {
   SPAGAIN;
   svp = sp + offset;
   count += Audio_filter_sv(aTHX_ au,func,tmp,svp[i]);
  }
 SPAGAIN;
 svp = sp + offset;
 if (GIMME == G_ARRAY)
  {
   float *s = AUDIO_DATA(tmp);
   if (count > items)
    EXTEND(sp,count);
   for (i=0; i < count; i++)
    {
     svp[i] = sv_2mortal(newSVnv(*s++));
    }
   PUTBACK;
   return count;
  }
 else
  {
   svp[0] = result;
   PUTBACK;
   return 1;
  }
}

void
Audio_append_sv(pTHX_ Audio *lau, SV *sv)
{
 Audio *rau = Audio_from_sv(aTHX_ sv);
 if (rau && AUDIO_COMPLEX(rau) && !AUDIO_COMPLEX(lau))
  {
   warn("Upgrade to complex");
   Audio_complex(lau);
  }
 if (rau)
  {
   int wrds = AUDIO_WORDS(lau);
   STRLEN n = Audio_samples(rau);
   float *d = Audio_more(aTHX_ lau,n);
   if (lau->rate != rau->rate)
    {
     if (lau->rate)
      {
       if (rau->rate)
        {
         croak("Cannot append %dHz data to %dHZ Audio",rau->rate,lau->rate);
	}
      }
     else
      {
       lau->rate = rau->rate;
      }
    }
   if (wrds == AUDIO_WORDS(rau))
    {
     Copy(AUDIO_DATA(rau),d,n*wrds,float);
    }
   else
    {
     float *s = AUDIO_DATA(rau);
     while (n-- > 0)
      {
       *d++ = *s++;
       *d++ = 0.0;
      }
    }
  }
 else if (SvROK(sv) && !sv_isobject(sv))
  {
   if (SvTYPE(SvRV(sv)) == SVt_PVAV)
    {
     AV *av = (AV *) SvRV(sv);
     int i;
     int l = av_len(av);
     for (i=0; i <= l; i++)
      {
       SV **svp = av_fetch(av,i,0);
       if (svp)
        Audio_append_sv(aTHX_ lau,*svp);
      }
    }
   else
    Perl_croak(aTHX_ "Cannot process reference");
  }
 else
  {
   float *d = Audio_more(aTHX_ lau,1);
   *d = (float) SvNV(sv);
  }
}

Audio *
Audio_overload_init(pTHX_ Audio *lau, SV **argp,int dorev, SV *right, SV *rev)
{
 SV *left  = argp[0];
 if (SvOK(rev))
  {
   /* Not assignment form */
   char *type = AUDIO_CLASS(left);
   SV *tsv = Nullsv;
   Audio *tau = Audio_new(aTHX_ &tsv,lau->rate,lau->flags,0,type);
   if (dorev && SvTRUE(rev))
    {
     SV *tsv = left;
     left    = right;
     argp[1] = tsv;
    }
   Audio_append_sv(aTHX_ tau,left);
   argp[0] = tsv;
   return tau;
  }
 return lau;
}

#line 395 "Data.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 537 "Data.c"

XS_EUPXS(XS_Audio__Data_shorts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_shorts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;
	SV *	RETVAL;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	RETVAL = Audio_shorts(au);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_silence); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_silence)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "au, time = 0.1");
    {
	Audio *	au;
	float	time;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    time = 0.1;
	else {
	    time = (float)SvNV(ST(1))
;
	}

	Audio_silence(au, time);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_tone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_tone)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "au, freq, dur = 0.1, amp = 0.5");
    {
	Audio *	au;
	float	freq = (float)SvNV(ST(1))
;
	float	dur;
	float	amp;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 3)
	    dur = 0.1;
	else {
	    dur = (float)SvNV(ST(2))
;
	}

	if (items < 4)
	    amp = 0.5;
	else {
	    amp = (float)SvNV(ST(3))
;
	}

	Audio_tone(au, freq, dur, amp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_noise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_noise)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "au, dur = 0.1, amp = 0.5");
    {
	Audio *	au;
	float	dur;
	float	amp;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    dur = 0.1;
	else {
	    dur = (float)SvNV(ST(1))
;
	}

	if (items < 3)
	    amp = 0.5;
	else {
	    amp = (float)SvNV(ST(2))
;
	}

	Audio_noise(au, dur, amp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 415 "Data.xs"
 {
  if (au->comment)
   SvREFCNT_dec(au->comment);
  if (au->data)
   SvREFCNT_dec(au->data);
 }
#line 711 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Data_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
#line 426 "Data.xs"
  Audio x;
#line 729 "Data.c"
	Audio *	RETVAL;
#line 428 "Data.xs"
 {
  Zero(&x,1,Audio);
  x.comment = newSV(0);
  x.data    = newSVpv("",0);
  RETVAL    = &x;
 }
#line 738 "Data.c"
	ST(0) = sv_newmortal();
	sv_setref_pvn(ST(0), (class) ? class : "Audio::Data", (char *) RETVAL, sizeof(*RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 440 "Data.xs"
{
 SV *result = Nullsv;
 Audio *rau = Audio_new(aTHX_ &result,au->rate,au->flags,0,AUDIO_CLASS(ST(0)));
 Audio_append_sv(aTHX_ rau, ST(0));
 ST(0) = result;
 XSRETURN(1);
}
#line 772 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_timerange); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_timerange)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "au, t0, t1");
    {
	Audio *	au;
	float	t0 = (float)SvNV(ST(1))
;
	float	t1 = (float)SvNV(ST(2))
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 451 "Data.xs"
{
 SV *result = Nullsv;
 UV samples = Audio_samples(au);
 UV start = au->rate*t0;
 UV end   = au->rate*t1+0.5;
 Audio *rau = Audio_new(aTHX_ &result,au->rate,au->flags,end-start,AUDIO_CLASS(ST(0)));
 if (start < samples)
  {
   float *d   = AUDIO_DATA(rau);
   float *s   = AUDIO_DATA(au)+start;
   if (end > samples)
    end = samples;
   Copy(s,d,(end-start)*AUDIO_WORDS(au),float);
  }
 ST(0) = result;
 XSRETURN(1);
}
#line 818 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_bounds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_bounds)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "au, t0= 0.0, t1= Audio_duration(au)");
    {
	Audio *	au;
	float	t0;
	float	t1;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    t0 = 0.0;
	else {
	    t0 = (float)SvNV(ST(1))
;
	}

	if (items < 3)
	    t1 = Audio_duration(au);
	else {
	    t1 = (float)SvNV(ST(2))
;
	}
#line 472 "Data.xs"
{
 UV samples = Audio_samples(au);
 UV start = au->rate*t0;
 UV end   = au->rate*t1+0.5;
 if (start < samples)
  {
   float *s   = AUDIO_DATA(au)+start;
   float *e;
   float max = *s++;
   float min = max;
   if (end > samples)
    end = samples;
   e = AUDIO_DATA(au)+end;
   while (s < e)
    {
     float v = *s++;
     if (v > max) max = v;
     if (v < min) min = v;
    }
   ST(0) = sv_2mortal(newSVnv(max));
   ST(1) = sv_2mortal(newSVnv(min));
   XSRETURN(2);
  }
 XSRETURN(0);
}
#line 884 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_comment); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_comment)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "au, ...");
    {
	Audio *	au;
	SV *	RETVAL;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 502 "Data.xs"
 {
  if (items > 1)
   {
    if (!au->comment)
     au->comment = newSV(0);
    sv_setsv(au->comment,ST(1));
   }
  RETVAL = SvREFCNT_inc(au->comment);
 }
#line 919 "Data.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "au, index");
    {
	Audio *	au;
	UV	index = (UV)SvUV(ST(1))
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 519 "Data.xs"
 {
  if (index < Audio_samples(au))
   {
    float *src = AUDIO_DATA(au)+(index * AUDIO_WORDS(au));
    if (AUDIO_COMPLEX(au) && src[1] != 0.0)
     {
      SV *result = Nullsv;
      Audio *tau = Audio_new(aTHX_ &result,au->rate, au->flags, 1,0);
      tau->flags |= AUDIO_F_COMPLEX;
      Copy(src,AUDIO_DATA(tau),AUDIO_WORDS(au),float);
      ST(0) = result;
     }
    else
     {
      ST(0) = sv_2mortal(newSVnv(*src));
     }
   }
  else
   {
    ST(0) = &PL_sv_undef;
   }
  XSRETURN(1);
 }
#line 971 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "au, index, sv");
    {
	Audio *	au;
	IV	index = (IV)SvIV(ST(1))
;
	SV *	sv = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 549 "Data.xs"
 {
  IV n = Audio_samples(au);
  IV len = 1;
  float v[2];
  float *src = v;
  float *dst;
  /* If value stored is an Audio */
  if (SvROK(sv) && sv_isobject(sv) && sv_derived_from(sv,"Audio::Data"))
   {
    Audio *auv = (Audio *) SvPV_nolen(SvRV(sv));
    if (AUDIO_COMPLEX(auv))
     Audio_complex(au);
    len  = Audio_samples(auv);
    if (len > 1 && auv->rate != au->rate)
     {
      croak("Cannot store %dHz data in %dHZ Audio",auv->rate,au->rate);
     }
    src  = AUDIO_DATA(auv);
   }
  else
   {
    v[0] = SvNV(sv);
    v[1] = 0.0;
   }
  if (index+len-1 > n)
   Audio_more(aTHX_ au,(index-n));
  dst = AUDIO_DATA(au)+(index*AUDIO_WORDS(au));
  Copy(src,dst,len*AUDIO_WORDS(au),float);
 }
#line 1029 "Data.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_samples); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_samples)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "au, ...");
    {
	Audio *	au;
	IV	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	RETVAL = Audio_samples(au);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_length)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "au, ...");
    {
	Audio *	au;
	IV	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 587 "Data.xs"
 {
  RETVAL = Audio_samples(au);
  if (items > 1)
   {
    IV want = SvIV(ST(1));
    if (want > RETVAL)
     Audio_more(aTHX_ au,want-RETVAL);
    else if (want < RETVAL)
     {
      STRLEN sz = want * sizeof(float) * AUDIO_WORDS(au);
      SvCUR_set(au->data,sz);
     }
   }
 }
#line 1098 "Data.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_duration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_duration)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;
	float	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	RETVAL = Audio_duration(au);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_rate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_rate)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "au, rate = 0");
    {
	Audio *	au;
	IV	rate;
	IV	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    rate = 0;
	else {
	    rate = (IV)SvIV(ST(1))
;
	}

	RETVAL = Audio_rate(au, rate);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_concat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_concat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lau, right, rev");
    {
	Audio *	lau;
	SV *	right = ST(1)
;
	SV *	rev = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    lau = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*lau))
	      croak("lau is not large enough");
	}
	else
	    croak("lau is not an object")
;
#line 619 "Data.xs"
 {
  Audio *dau = Audio_overload_init(aTHX_ lau, &ST(0),1,right,rev);
  Audio_append_sv(aTHX_ dau, ST(1));
  XSRETURN(1);
 }
#line 1197 "Data.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lau, right, rev");
    {
	Audio *	lau;
	SV *	right = ST(1)
;
	SV *	rev = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    lau = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*lau))
	      croak("lau is not large enough");
	}
	else
	    croak("lau is not an object")
;
#line 631 "Data.xs"
 {
  Audio *rau;
  lau = Audio_overload_init(aTHX_ lau, &ST(0),0,right,rev);
  rau = Audio_from_sv(aTHX_ ST(1));
  if (rau)
   {
    int n = Audio_samples(rau);
    int m = Audio_samples(lau);
    float *d = AUDIO_DATA(rau);
    float *s;
    int skip = 0;
    if (m < n)
     Audio_more(aTHX_ lau,n-m);
    s = (AUDIO_COMPLEX(rau)) ? Audio_complex(lau) : AUDIO_DATA(lau);
    if (AUDIO_COMPLEX(lau) && !AUDIO_COMPLEX(rau))
     skip = 1;
    while (n-- > 0)
     {
      *s++ += *d++;
      s += skip;
     }
   }
  else
   {
    int m = Audio_samples(lau);
    float *s = AUDIO_DATA(lau);
    float v = SvNV(ST(1));
    int skip = (AUDIO_COMPLEX(lau)) ? 2 : 1;
    while (m-- > 0)
     {
      *s += v;
      s += skip;
     }
   }
  XSRETURN(1);
 }
#line 1262 "Data.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lau, right, rev");
    {
	Audio *	lau;
	SV *	right = ST(1)
;
	SV *	rev = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    lau = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*lau))
	      croak("lau is not large enough");
	}
	else
	    croak("lau is not an object")
;
#line 674 "Data.xs"
 {
  Audio *rau;
  lau = Audio_overload_init(aTHX_ lau, &ST(0),0,right,rev);
  rau = Audio_from_sv(aTHX_ ST(1));
  if (rau)
   {
    int n = Audio_samples(rau);
    int m = Audio_samples(lau);
    float *d = AUDIO_DATA(rau);
    float *s;
    int skip = 0;
    if (m < n)
     Audio_more(aTHX_ lau,n-m);
    s = (AUDIO_COMPLEX(rau)) ? Audio_complex(lau) : AUDIO_DATA(lau);
    if (AUDIO_COMPLEX(lau) && !AUDIO_COMPLEX(rau))
     skip = 1;
    while (n-- > 0)
     {
      *s++ -= *d++;
      s += skip;
     }
   }
  else
   {
    int r = SvTRUE(rev);
    int m = Audio_samples(lau);
    float *s = AUDIO_DATA(lau);
    float v = SvNV(ST(1));
    int skip = (AUDIO_COMPLEX(lau)) ? 2 : 1;
    while (m-- > 0)
     {
      if (r)
       {
        *s = v - *s;
        if (AUDIO_COMPLEX(lau))
         s[1] = -s[1];
       }
      else
       *s -= v;
      s += skip;
     }
   }
  XSRETURN(1);
 }
#line 1335 "Data.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_mpy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_mpy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lau, right, rev");
    {
	Audio *	lau;
	SV *	right = ST(1)
;
	SV *	rev = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    lau = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*lau))
	      croak("lau is not large enough");
	}
	else
	    croak("lau is not an object")
;
#line 725 "Data.xs"
 {
  Audio *rau;
  lau = Audio_overload_init(aTHX_ lau, &ST(0),0,right,rev);
  rau = Audio_from_sv(aTHX_ ST(1));
  if (rau)
   {
    Perl_croak(aTHX_ "Convolution not implemented yet");
   }
  else
   {
    int m = Audio_samples(lau);
    float *s = AUDIO_DATA(lau);
    float v = SvNV(ST(1));
    m *= AUDIO_WORDS(lau);
    while (m-- > 0)
     {
      *s++ *= v;
     }
   }
  XSRETURN(1);
 }
#line 1385 "Data.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lau, right, rev");
    {
	Audio *	lau;
	SV *	right = ST(1)
;
	SV *	rev = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    lau = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*lau))
	      croak("lau is not large enough");
	}
	else
	    croak("lau is not an object")
;
#line 753 "Data.xs"
 {
  Audio *rau;
  lau = Audio_overload_init(aTHX_ lau, &ST(0),0,right,rev);
  rau = Audio_from_sv(aTHX_ ST(1));
  if (rau)
   {
    Perl_croak(aTHX_ "Divide not two Audios not given meaning yet");
   }
  else
   {
    int r = SvTRUE(rev);
    int n = Audio_samples(lau);
    int m = n;
    float *s = AUDIO_DATA(lau);
    float v = SvNV(ST(1));
    int skip = (AUDIO_COMPLEX(lau) && r) ? 2 : 1;
    m *= AUDIO_WORDS(lau)/skip;
    while (m-- > 0)
     {
      if (r)
       {
        if (AUDIO_COMPLEX(lau))
         {float a = s[0];
          float b = s[1];
          float d = a*a + b*b;
          s[0] = v*a/d;
          s[1] = -b*v/d;
         }
        else
         *s = v / *s;
       }
      else
       {
        *s /= v;
       }	
      s += skip;
     }
   }
  XSRETURN(1);
 }
#line 1454 "Data.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_hamming); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_hamming)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "au, N, start = 0, k = 0.46");
    {
	Audio *	au;
	IV	N = (IV)SvIV(ST(1))
;
	IV	start;
	double	k;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 3)
	    start = 0;
	else {
	    start = (IV)SvIV(ST(2))
;
	}

	if (items < 4)
	    k = 0.46;
	else {
	    k = (double)SvNV(ST(3))
;
	}
#line 801 "Data.xs"
 {
  Audio tmp;
  float *s = AUDIO_DATA(au)+start;
  float *e = AUDIO_DATA(au)+Audio_samples(au);
  float *d;
  IV i;
  int complex = AUDIO_COMPLEX(au);
  double half_N = (double)N / 2.0;
  Zero(&tmp,1,Audio);
  tmp.data = newSVpvn("",0);
  tmp.rate = au->rate;
  if (complex)
   tmp.flags = AUDIO_F_COMPLEX;
  d = Audio_more(aTHX_ &tmp,N);
  for (i=0; i < N && s < e; i++)
   {double x = ((double) i - half_N)/half_N;
    double w = ((1.0-k)+k*cos(x*AUDIO_PI));
    *d++ = *s++ * w;
    if (complex)
     *d++ = *s++ * w;
   }
  sv_setref_pvn((ST(0) = sv_2mortal(newSV(0))),"Audio::Data",(char *)&tmp,sizeof(tmp));
  XSRETURN(1);
 }
#line 1521 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_autocorrelation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_autocorrelation)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "au, p");
    {
	Audio *	au;
	int	p = (int)SvIV(ST(1))
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 831 "Data.xs"
 {
  char *type = AUDIO_CLASS(ST(0));
  SV *result = Nullsv;
  Audio *tmp = Audio_new(aTHX_ &result,au->rate, 0, p+1,type);
  float *x = AUDIO_DATA(au);
  float *d = AUDIO_DATA(tmp);
  Audio_autocorrelation(Audio_samples(au),x,p,d);
  ST(0) = result;
  XSRETURN(1);
 }
#line 1558 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_difference); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_difference)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 846 "Data.xs"
 {
  Audio tmp;
  int n = Audio_samples(au)-1;
  float *x = AUDIO_DATA(au);
  float *d;
  Zero(&tmp,1,Audio);
  tmp.data = newSVpvn("",0);
  tmp.rate = au->rate;
  d = Audio_more(aTHX_ &tmp,n);
  Audio_difference(n,x,d);
  sv_setref_pvn((ST(0) = sv_2mortal(newSV(0))),"Audio::Data",(char *)&tmp,sizeof(tmp));
  XSRETURN(1);
 }
#line 1596 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_lpc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_lpc)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "au, order, ac= 0, rf= 0");
    {
	Audio *	au;
	int	order = (int)SvIV(ST(1))
;
	SV *	ac;
	SV *	rf;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 3)
	    ac = 0;
	else {
	    ac = ST(2)
;
	}

	if (items < 4)
	    rf = 0;
	else {
	    rf = ST(3)
;
	}
#line 863 "Data.xs"
{
 char *type = AUDIO_CLASS(ST(0));
 SV *result = Nullsv;
 Audio *lpc = Audio_new(aTHX_ &result,au->rate, 0, order+1,type);
 float *acf = AUDIO_DATA(Audio_new(aTHX_ &ac, au->rate, 0, order+1,type));
 float *ref = AUDIO_DATA(Audio_new(aTHX_ &rf, au->rate, 0, order+1,type));
 int length = Audio_samples(au);
 float *sig = AUDIO_DATA(au);
 if (AUDIO_COMPLEX(au))
  croak("Cannot process complex data");
 order = Audio_lpc(length,sig,order,acf,ref,AUDIO_DATA(lpc));
 ST(0) = result;
 XSRETURN(1);
}
#line 1653 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_durbin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_durbin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 883 "Data.xs"
 {
  int n = Audio_samples(au);
  SV *result = Nullsv;
  Audio *tmp = Audio_new(aTHX_ &result,au->rate,au->flags,n,AUDIO_CLASS(ST(0)));
  float *x = AUDIO_DATA(au);
  float *d = AUDIO_DATA(tmp);
  if (AUDIO_COMPLEX(au))
   croak("Cannot process complex data");
  Audio_durbin(n-1,x,d);
  ST(0) = result;
  XSRETURN(1);
 }
#line 1690 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_conjugate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_conjugate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "au, right, rev");
    {
	Audio *	au;
	SV *	right = ST(1)
;
	SV *	rev = ST(2)
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 902 "Data.xs"
 {
  ST(2) = &PL_sv_no;
  au = Audio_overload_init(aTHX_ au, &ST(0),0,right,rev);
  Audio_conjugate(Audio_samples(au),Audio_complex(au),1.0);
 }
#line 1724 "Data.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Data_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_data)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "au, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 912 "Data.xs"
 {
  int gimme = GIMME_V;
  if (items > 1)
   {
    int i;
    au->flags &= ~AUDIO_F_COMPLEX;
    SvCUR(au->data) = 0;
    for (i=1; i < items; i++)
     {
      Audio_append_sv(aTHX_ au,ST(i));
     }
   }
  if (gimme == G_VOID)
   {
    XSRETURN(0);
   }
  else if (gimme == G_ARRAY)
   {
    STRLEN sz;
    int count = 0;
    float *p = (float *) SvPV(au->data,sz);
    while (sz >= sizeof(float))
     {
      double d = *p++;
      XPUSHs(sv_2mortal(newSVnv(d)));
      sz -= sizeof(float);
      count++;
     }
    XSRETURN(count);
   }
  else
   {
    XPUSHs(SvREFCNT_inc(au->data));
    XSRETURN(1);
   }
 }
#line 1787 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Data_dB); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_dB)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "au, start = 0, count = (GIMME == G_ARRAY) ? Audio_samples(au)-start : 1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;
	int	start;
	int	count;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    start = 0;
	else {
	    start = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    count = (GIMME == G_ARRAY) ? Audio_samples(au)-start : 1;
	else {
	    count = (int)SvIV(ST(2))
;
	}
#line 955 "Data.xs"
 {
  int n = Audio_samples(au);
  float *p = AUDIO_DATA(au)+start*AUDIO_WORDS(au);
  /* Min noticable value in 16bit is 1/(2**15) - call that 100dB */
  float min = 1.0/(1 << 15);
  float dB0 = 10*log10(min);
  if (start+count > n)
   count = n - start;
  if (AUDIO_COMPLEX(au))
   {
    for (n=0; n < count; n++)
     {
      float r = *p++;
      float i = *p++;
      r = sqrt(r*r+i*i);
      /* hack to avoid log10(0) yielding NaN or fault */
      if (r < min)
       r = min;
      XPUSHs(sv_2mortal(newSVnv(10*log10(r)-dB0)));
     }
   }
  else
   {
    for (n=0; n < count; n++)
     {
      float r = *p++;
      if (r < 0)
       r = -r;
      /* hack to avoid log10(0) yielding NaN or fault */
      if (r < min)
       r = min;
      XPUSHs(sv_2mortal(newSVnv(10*log10(r)-dB0)));
     }
   }
  XSRETURN(count);
 }
#line 1867 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Data_amplitude); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_amplitude)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "au, start = 0, count = (GIMME == G_ARRAY) ? Audio_samples(au)-start : 1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;
	int	start;
	int	count;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    start = 0;
	else {
	    start = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    count = (GIMME == G_ARRAY) ? Audio_samples(au)-start : 1;
	else {
	    count = (int)SvIV(ST(2))
;
	}
#line 998 "Data.xs"
 {
  int n = Audio_samples(au);
  float *p = AUDIO_DATA(au)+start*AUDIO_WORDS(au);
  if (start+count > n)
   count = n - start;
  if (AUDIO_COMPLEX(au))
   {
    for (n=0; n < count; n++)
     {
      float r = *p++;
      float i = *p++;
      XPUSHs(sv_2mortal(newSVnv(sqrt(r*r+i*i))));
     }
   }
  else
   {
    for (n=0; n < count; n++)
     {
      float r = *p++;
      XPUSHs(sv_2mortal(newSVnv(r)));
     }
   }
  XSRETURN(count);
 }
#line 1935 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Data_phase); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_phase)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "au, start = 0, count = (GIMME == G_ARRAY) ? Audio_samples(au)-start : 1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;
	int	start;
	int	count;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    start = 0;
	else {
	    start = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    count = (GIMME == G_ARRAY) ? Audio_samples(au)-start : 1;
	else {
	    count = (int)SvIV(ST(2))
;
	}
#line 1029 "Data.xs"
 {
  int n = Audio_samples(au);
  float *p = AUDIO_DATA(au)+start*AUDIO_WORDS(au);
  if (start+count > n)
   count = n - start;
  if (AUDIO_COMPLEX(au))
   {
    for (n=0; n < count; n++)
     {
      float r = *p++;
      float i = *p++;
      XPUSHs(sv_2mortal(newSVnv(atan2(i,r))));
     }
   }
  else
   {
    for (n=0; n < count; n++)
     {
      XPUSHs(sv_2mortal(newSVnv(0)));
     }
   }
  XSRETURN(count);
 }
#line 2002 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Data_Load); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_Load)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "au, fh");
    {
	Audio *	au;
	InputStream	fh = IoIFP(sv_2io(ST(1)))
;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	Audio_Load(au, fh);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_Save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_Save)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "au, fh, comment = NULL");
    {
	Audio *	au;
	OutputStream	fh = IoOFP(sv_2io(ST(1)))
;
	char *	comment;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 3)
	    comment = NULL;
	else {
	    comment = (char *)SvPV_nolen(ST(2))
;
	}

	Audio_Save(au, fh, comment);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Filter__AllPole_process); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Filter__AllPole_process)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "au, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 1071 "Data.xs"
 {
  XSRETURN(Audio_filter_process(aTHX_ au,&Audio_AllPole,items,&ST(0)));
 }
#line 2095 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Filter__FIR_process); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Filter__FIR_process)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "au, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;
#line 1081 "Data.xs"
 {
  XSRETURN(Audio_filter_process(aTHX_ au,&Audio_FIR,items,&ST(0)));
 }
#line 2126 "Data.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Audio__Data_r2_fft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_r2_fft)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	AUDIO_r2_fft(au);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_r2_ifft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_r2_ifft)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	AUDIO_r2_ifft(au);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_r4_fft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_r4_fft)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	AUDIO_r4_fft(au);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_r4_ifft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_r4_ifft)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "au");
    {
	Audio *	au;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	AUDIO_r4_ifft(au);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Data_complex_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Data_complex_debug)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "au, f = PerlIO_stdout()");
    {
	Audio *	au;
	OutputStream	f;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 2)
	    f = PerlIO_stdout();
	else {
	    f = IoOFP(sv_2io(ST(1)))
;
	}

	AUDIO_complex_debug(au, f);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Audio__Data); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Audio__Data)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Audio::Data::shorts", XS_Audio__Data_shorts, file);
        newXS("Audio::Data::silence", XS_Audio__Data_silence, file);
        newXS("Audio::Data::tone", XS_Audio__Data_tone, file);
        newXS("Audio::Data::noise", XS_Audio__Data_noise, file);
        newXS("Audio::Data::DESTROY", XS_Audio__Data_DESTROY, file);
        newXS("Audio::Data::create", XS_Audio__Data_create, file);
        newXS("Audio::Data::clone", XS_Audio__Data_clone, file);
        newXS("Audio::Data::timerange", XS_Audio__Data_timerange, file);
        newXS("Audio::Data::bounds", XS_Audio__Data_bounds, file);
        newXS("Audio::Data::comment", XS_Audio__Data_comment, file);
        newXS("Audio::Data::FETCH", XS_Audio__Data_FETCH, file);
        newXS("Audio::Data::STORE", XS_Audio__Data_STORE, file);
        newXS("Audio::Data::samples", XS_Audio__Data_samples, file);
        newXS("Audio::Data::length", XS_Audio__Data_length, file);
        newXS("Audio::Data::duration", XS_Audio__Data_duration, file);
        newXS("Audio::Data::rate", XS_Audio__Data_rate, file);
        newXS("Audio::Data::concat", XS_Audio__Data_concat, file);
        newXS("Audio::Data::add", XS_Audio__Data_add, file);
        newXS("Audio::Data::sub", XS_Audio__Data_sub, file);
        newXS("Audio::Data::mpy", XS_Audio__Data_mpy, file);
        newXS("Audio::Data::div", XS_Audio__Data_div, file);
        newXS("Audio::Data::hamming", XS_Audio__Data_hamming, file);
        newXS("Audio::Data::autocorrelation", XS_Audio__Data_autocorrelation, file);
        newXS("Audio::Data::difference", XS_Audio__Data_difference, file);
        newXS("Audio::Data::lpc", XS_Audio__Data_lpc, file);
        newXS("Audio::Data::durbin", XS_Audio__Data_durbin, file);
        newXS("Audio::Data::conjugate", XS_Audio__Data_conjugate, file);
        newXS("Audio::Data::data", XS_Audio__Data_data, file);
        newXS("Audio::Data::dB", XS_Audio__Data_dB, file);
        newXS("Audio::Data::amplitude", XS_Audio__Data_amplitude, file);
        newXS("Audio::Data::phase", XS_Audio__Data_phase, file);
        newXS("Audio::Data::Load", XS_Audio__Data_Load, file);
        newXS("Audio::Data::Save", XS_Audio__Data_Save, file);
        newXS("Audio::Filter::AllPole::process", XS_Audio__Filter__AllPole_process, file);
        newXS("Audio::Filter::FIR::process", XS_Audio__Filter__FIR_process, file);
        newXS("Audio::Data::r2_fft", XS_Audio__Data_r2_fft, file);
        newXS("Audio::Data::r2_ifft", XS_Audio__Data_r2_ifft, file);
        newXS("Audio::Data::r4_fft", XS_Audio__Data_r4_fft, file);
        newXS("Audio::Data::r4_ifft", XS_Audio__Data_r4_ifft, file);
        newXS("Audio::Data::complex_debug", XS_Audio__Data_complex_debug, file);

    /* Initialisation Section */

#line 1110 "Data.xs"
 {
  sv_setiv(perl_get_sv("Audio::Data::AudioVtab",1),(IV) AudioVGet());
 }

#line 2333 "Data.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

